ifeq ($(TARGET_CPU), $(filter $(TARGET_CPU), x86_64 A72 A53))

include $(PRELUDE)

CSOURCES    := app_single_cam_common.c
TARGET      := vx_app_single_cam_codec
TARGETTYPE  := exe



ifeq ($(TARGET_CPU),x86_64)
CSOURCES    += main_x86.c
include $(VISION_APPS_PATH)/apps/concerto_x86_64_inc.mak
STATIC_LIBS += $(IMAGING_LIBS)
endif

ifeq ($(TARGET_CPU),$(filter $(TARGET_CPU), A72 A53))
ifeq ($(TARGET_OS), $(filter $(TARGET_OS), LINUX QNX))
CSOURCES    += app_single_cam_main.c
CSOURCES    += main_linux_arm.c
include $(VISION_APPS_PATH)/apps/concerto_mpu_inc.mak

endif
endif

IDIRS += $(IMAGING_IDIRS)
IDIRS += $(VISION_APPS_KERNELS_IDIRS)
IDIRS += $(VISION_APPS_MODULES_IDIRS)

STATIC_LIBS += $(IMAGING_LIBS)
STATIC_LIBS += $(VISION_APPS_KERNELS_LIBS)
STATIC_LIBS += $(VISION_APPS_MODULES_LIBS)

STATIC_LIBS += app_utils_codec_wrapper

ifeq ($(TARGET_OS), LINUX)
STATIC_LIBS += app_utils_gst_wrapper

SHARED_LIBS += gstreamer-1.0
SHARED_LIBS += gstapp-1.0
SHARED_LIBS += gstbase-1.0
SHARED_LIBS += gobject-2.0
SHARED_LIBS += glib-2.0

CFLAGS += -Wno-restrict
CFLAGS += -Wno-stringop-overflow
endif

ifeq ($(TARGET_OS), QNX)
STATIC_LIBS += app_utils_omax_wrapper

ifeq ($(TARGET_PLATFORM), $(filter $(TARGET_PLATFORM), J784S4 J721S2))
LDIRS += $(PSDK_QNX_PATH)/qnx/codec/vpu/OpenMAXIL/core/nto/aarch64/$(BUILD_PROFILE_QNX_SO)/
LDIRS += $(PSDK_QNX_PATH)/qnx/codec/vpu/OpenMAXIL/utility/nto/aarch64/$(BUILD_PROFILE_QNX_SO)/

CFLAGS      += -DCODEC_USE_HIGHMEM
endif

ifeq ($(TARGET_PLATFORM), $(filter $(TARGET_PLATFORM), J721E))
LDIRS += $(PSDK_QNX_PATH)/qnx/codec/img/qnx/OpenMAXIL/core/nto/aarch64/$(BUILD_PROFILE_QNX_SO)/
LDIRS += $(PSDK_QNX_PATH)/qnx/codec/img/qnx/OpenMAXIL/utility/nto/aarch64/$(BUILD_PROFILE_QNX_SO)/
endif

ifeq ($(TARGET_BUILD), release)
SHARED_LIBS += omxcore_j7$(BUILD_PROFILE_QNX_SUFFIX)
SHARED_LIBS += omxil_j7_utility$(BUILD_PROFILE_QNX_SUFFIX)
endif
ifeq ($(TARGET_BUILD), debug)
CFLAGS      += -DDEBUG_MODE
SHARED_LIBS += slog2
STATIC_LIBS += omxcore_j7$(BUILD_PROFILE_QNX_SUFFIX)S
STATIC_LIBS += omxil_j7_utility$(BUILD_PROFILE_QNX_SUFFIX)S
endif

endif

ifeq ($(TARGET_CPU),$(filter $(TARGET_CPU), A72 A53))
ifeq ($(TARGET_OS),SYSBIOS)

TARGETTYPE  := library

include $(VISION_APPS_PATH)/apps/concerto_mpu_inc.mak

endif
endif

IDIRS += $(IMAGING_IDIRS)

include $(FINALE)

endif
